
#include <exception>

#include "gui/gui.h"
#include "qapphost.h"
#include "QTemporaryDir"

QAppHost* host;
Gui* gui;

void boot()
{
    if (gui == nullptr)
    {
        gui = new Gui();
        TelemetryState tele;
        tele.timestamp = 0;
        tele.speed = 9.72222222222;
        tele.rpm = 1000;
        tele.gear = 7;
        gui->setPause(false);
        gui->receiveTelemetry(tele);
        gui->setVisible(true);
    }
}

int main(int argc, char** argv)
{

    try
    {
        if (host == nullptr)
        {
            host = new QAppHost(&boot);
//            std::this_thread::sleep_for(std::chrono::seconds(1));
        }

        host->waitForThread();
    }
    catch (std::exception ex)
    {
        std::cerr << "Killed by exception: " << ex.what() << std::endl;
        return SCS_RESULT_generic_error;
    }

    std::cout << "Execution finished." << std::endl;
}
