#include "qapphost.h"

#include <QDebug>
#include <iostream>
#include <QTimer>
#include <thread>
#ifdef WITH_QT_JSON_SETTINGS
#include <qt_json_settings.h>
#endif

int argc = 1;
char* argv[] = {"SharedLibrary", nullptr};
char** nargv = nullptr;

QAppHost::QAppHost(std::function<void(void)> callback)
{
    callbackFunction = callback;
    std::cout << "QAppHost::QAppHost()" << std::endl;
    if (thread == nullptr)
    {
        thread = new std::thread(&QAppHost::threadRun, this);
        std::cout << "Host thread created." << std::endl;
    }
}

//QAppHost::QAppHost(int& nargc, char** args)
//{
//    argc = nargc;
//    nargv = args;
//    std::cout << "QAppHost::QAppHost()" << std::endl;
//    if (thread == nullptr)
//    {
//        thread = new std::thread(&QAppHost::threadRun, this);
//        std::cout << "Host thread created." << std::endl;
//    }
//}

//QAppHost::~QAppHost()
//{
//    qDebug() << "QAppHost::~QAppHost()";
//    if (app != nullptr)
//    {
//        delete app;
//        qDebug() << "App deleted.";
//    }
//    if (thread != nullptr)
//    {
//        delete thread;
//        qDebug() << "Thread deleted.";
//    }
//}

void QAppHost::waitForThread()
{
    if (thread != nullptr && thread->joinable())
        thread->join();
}

void QAppHost::threadRun()
{
    std::cout << "QAppHost::threadRun()" << std::endl;

    if (QApplication::instance() == nullptr)
    {
        app = new QApplication(argc, nargv == nullptr ? argv : nargv);
        std::cout << "App created." << std::endl;

        QCoreApplication::setOrganizationName("Catboy Labs");
        QCoreApplication::setOrganizationDomain("mysoft.com");
        QCoreApplication::setApplicationName("Euro Fuck Simulator");
#ifdef WITH_QT_JSON_SETTINGS
        QtJsonSettings::Initialize();
#endif

        QTimer::singleShot(250, callbackFunction);
        std::cout << "Boot timer created." << std::endl;

        app->exec();
        qDebug() << "App finished executing.";
    }

    qDebug() << "QAppHost::threadRun() finished";
}

void QAppHost::shutdown()
{
    qDebug() << "QAppHost::shutdown()";
    if (QApplication::instance() != nullptr)
    {
        QApplication::instance()->quit();
        qDebug() << "App quit.";
    }
//    if (thread != nullptr && thread->joinable())
//    {
//        qDebug() << "Thread joining...";
//        thread->join();
//        qDebug() << "Thread joined.";
//    }
    qDebug() << "QAppHost::shutdown() finished";
}
